#!/usr/bin/perl -w

## recoit le nom d'un fichier .pps
$source = "$ARGV[0]";

## lecture du source, et stockage ds le tableau @le_source
$i = 0;
open (SRC, $source) or die "ouverture du fichier $source impossible";
while ($ligne = <SRC>) {
    ## suppression des commentaires
    if ($ligne =~ /%/) {
       $ligne =~ s/%.*$//;
    }
    ## remplacement des tabulations
    if ($ligne =~ /\t/) {
        $ligne =~ s/\t/ /g;
    };
    ## remplacement des (){}[]!
    if ($ligne =~ /\(|\)|{|}|\[|\]|!/) {
           $ligne =~ s/\(|\)|{|}|\[|\]|!/ /g;
    }
##     ## remplacement des doubles espaces
##     while ($ligne =~ /  /) {
## 	      $ligne =~ s/  / /g;
##     }    
    $ligne =~ s/\r\n//;
##    $ligne =~ s/\n//;

##    print ("$i : " . $ligne);

    $le_source [$i] = $ligne;
    $i = $i + 1;
};
close (SRC);

## on cherche les cles definies dans le fichier
$i = 0;
foreach $ligne (@le_source) {
    ## la ligne definit une nouvelle cle
    if ($ligne =~ /^\//) {
        ## on l'efface de la ligne
        $ligne =~ s/^\/[^ ]*(.*)/$1/;
#	print ($ligne);
#	print ("== : " . $cle . "== \n");
    };
    ## on supprime les definitions locales
    while ($ligne =~ /\/[^ ]*(.*)/) {
	$ligne =~ s/\/[^ ]*(.*)/$1/;
    }
    ## on supprime les nombres
    while ($ligne =~ / [0-9]+ /) {
	$ligne =~ s/ [0-9]+ (.*)/ $1/;
    }
    while ($ligne =~ /^[0-9]+ /) {
	$ligne =~ s/^[0-9]+ (.*)/$1/;
    }
    ## on supprime les sauts de ligne
    $ligne =~ s/\n//;
};

## maintenant on recupere les appels
$i = 0;

foreach $ligne (@le_source) {
    @contenu = split (/ /, $ligne); 
    foreach (@contenu) {
	$element = $_;
        if ($element =~ /[a-zA-Z]/) {
	    $appel [$i] = $element;
	    $i++;
	}
    }
};

## maintenant on supprime les doublons
%deja_vu = ();
@uniques = ();
foreach $objet (@appel) {
    unless ($deja_vu{$objet}) {
        $deja_vu{$objet} = 1;
        push (@uniques, $objet);
    }
}


foreach (@uniques) {
    print ($_ . "\n");
};

1;
